common.rc 12.0 KB
Newer Older
1
#!/bin/bash
2 3 4 5 6 7 8 9 10 11 12 13 14 15 16
#
# Copyright (C) 2009 Red Hat, Inc.
# Copyright (c) 2000-2006 Silicon Graphics, Inc.  All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
17
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
18 19 20 21 22
#

dd()
{
   if [ "$HOSTOS" == "Linux" ]
K
Kevin Wolf 已提交
23 24 25 26 27 28 29 30 31
   then
        command dd --help | grep noxfer > /dev/null 2>&1

        if [ "$?" -eq 0 ]
            then
                command dd status=noxfer $@
            else
                command dd $@
            fi
32
   else
K
Kevin Wolf 已提交
33
        command dd $@
34 35 36
   fi
}

37 38 39 40 41 42
# poke_file 'test.img' 512 '\xff\xfe'
poke_file()
{
    printf "$3" | dd "of=$1" bs=1 "seek=$2" conv=notrunc &>/dev/null
}

43 44 45 46 47 48 49 50 51 52 53 54 55
# we need common.config
if [ "$iam" != "check" ]
then
    if ! . ./common.config
        then
        echo "$iam: failed to source common.config"
        exit 1
    fi
fi

# make sure we have a standard umask
umask 022

56 57
if [ "$IMGOPTSSYNTAX" = "true" ]; then
    DRIVER="driver=$IMGFMT"
58 59 60
    if [ "$IMGFMT" = "luks" ]; then
        DRIVER="$DRIVER,key-secret=keysec0"
    fi
61 62 63 64 65 66 67 68 69 70 71
    if [ "$IMGPROTO" = "file" ]; then
        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
        TEST_IMG="$DRIVER,file.filename=$TEST_DIR/t.$IMGFMT"
    elif [ "$IMGPROTO" = "nbd" ]; then
        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
        TEST_IMG="$DRIVER,file.driver=nbd,file.host=127.0.0.1,file.port=10810"
    elif [ "$IMGPROTO" = "ssh" ]; then
        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
        TEST_IMG="$DRIVER,file.driver=ssh,file.host=127.0.0.1,file.path=$TEST_IMG_FILE"
    elif [ "$IMGPROTO" = "nfs" ]; then
        TEST_DIR="$DRIVER,file.driver=nfs,file.filename=nfs://127.0.0.1/$TEST_DIR"
72
        TEST_IMG=$TEST_DIR/t.$IMGFMT
73 74 75 76 77
    elif [ "$IMGPROTO" = "archipelago" ]; then
        TEST_IMG="$DRIVER,file.driver=archipelago,file.volume=:at.$IMGFMT"
    else
        TEST_IMG="$DRIVER,file.driver=$IMGPROTO,file.filename=$TEST_DIR/t.$IMGFMT"
    fi
78
else
79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94
    if [ "$IMGPROTO" = "file" ]; then
        TEST_IMG=$TEST_DIR/t.$IMGFMT
    elif [ "$IMGPROTO" = "nbd" ]; then
        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
        TEST_IMG="nbd:127.0.0.1:10810"
    elif [ "$IMGPROTO" = "ssh" ]; then
        TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
        TEST_IMG="ssh://127.0.0.1$TEST_IMG_FILE"
    elif [ "$IMGPROTO" = "nfs" ]; then
        TEST_DIR="nfs://127.0.0.1/$TEST_DIR"
        TEST_IMG=$TEST_DIR/t.$IMGFMT
    elif [ "$IMGPROTO" = "archipelago" ]; then
        TEST_IMG="archipelago:at.$IMGFMT"
    else
        TEST_IMG=$IMGPROTO:$TEST_DIR/t.$IMGFMT
    fi
95
fi
96

97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112
_optstr_add()
{
    if [ -n "$1" ]; then
        echo "$1,$2"
    else
        echo "$2"
    fi
}

_set_default_imgopts()
{
    if [ "$IMGFMT" == "qcow2" ] && ! (echo "$IMGOPTS" | grep "compat=" > /dev/null); then
        IMGOPTS=$(_optstr_add "$IMGOPTS" "compat=1.1")
    fi
}

113 114 115 116 117 118 119 120 121 122 123 124
_use_sample_img()
{
    SAMPLE_IMG_FILE="${1%\.bz2}"
    TEST_IMG="$TEST_DIR/$SAMPLE_IMG_FILE"
    bzcat "$SAMPLE_IMG_DIR/$1" > "$TEST_IMG"
    if [ $? -ne 0 ]
    then
        echo "_use_sample_img error, cannot extract '$SAMPLE_IMG_DIR/$1'"
        exit 1
    fi
}

125 126 127 128
_make_test_img()
{
    # extra qemu-img options can be added by tests
    # at least one argument (the image size) needs to be added
129 130
    local extra_img_options=""
    local image_size=$*
131
    local optstr=""
132
    local img_name=""
133 134
    local use_backing=0
    local backing_file=""
135
    local object_options=""
136 137 138 139 140 141

    if [ -n "$TEST_IMG_FILE" ]; then
        img_name=$TEST_IMG_FILE
    else
        img_name=$TEST_IMG
    fi
142 143 144 145

    if [ -n "$IMGOPTS" ]; then
        optstr=$(_optstr_add "$optstr" "$IMGOPTS")
    fi
146 147 148 149
    if [ -n "$IMGKEYSECRET" ]; then
        object_options="--object secret,id=keysec0,data=$IMGKEYSECRET"
        optstr=$(_optstr_add "$optstr" "key-secret=keysec0")
    fi
150

151
    if [ "$1" = "-b" ]; then
152 153
        use_backing=1
        backing_file=$2
154 155
        image_size=$3
    fi
156
    if [ \( "$IMGFMT" = "qcow2" -o "$IMGFMT" = "qed" \) -a -n "$CLUSTER_SIZE" ]; then
157 158 159 160 161
        optstr=$(_optstr_add "$optstr" "cluster_size=$CLUSTER_SIZE")
    fi

    if [ -n "$optstr" ]; then
        extra_img_options="-o $optstr $extra_img_options"
162 163
    fi

164
    # XXX(hch): have global image options?
165 166
    (
     if [ $use_backing = 1 ]; then
167
        $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options -b "$backing_file" "$img_name" $image_size 2>&1
168
     else
169
        $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options "$img_name" $image_size 2>&1
170
     fi
171
    ) | _filter_img_create
172 173 174

    # Start an NBD server on the image file, which is what we'll be talking to
    if [ $IMGPROTO = "nbd" ]; then
M
Max Reitz 已提交
175
        eval "$QEMU_NBD -v -t -b 127.0.0.1 -p 10810 -f $IMGFMT  $TEST_IMG_FILE &"
176 177
        sleep 1 # FIXME: qemu-nbd needs to be listening before we continue
    fi
178 179
}

180 181 182 183 184
_rm_test_img()
{
    local img=$1
    if [ "$IMGFMT" = "vmdk" ]; then
        # Remove all the extents for vmdk
185
        "$QEMU_IMG" info "$img" 2>/dev/null | grep 'filename:' | cut -f 2 -d: \
186 187
            | xargs -I {} rm -f "{}"
    fi
188
    rm -f "$img"
189 190
}

191 192
_cleanup_test_img()
{
193 194
    case "$IMGPROTO" in

195
        nbd)
196
            if [ -f "${QEMU_TEST_DIR}/qemu-nbd.pid" ]; then
197
                local QEMU_NBD_PID
198
                read QEMU_NBD_PID < "${QEMU_TEST_DIR}/qemu-nbd.pid"
199
                kill ${QEMU_NBD_PID}
200
                rm -f "${QEMU_TEST_DIR}/qemu-nbd.pid"
201
            fi
202
            rm -f "$TEST_IMG_FILE"
203
            ;;
204
        file)
205 206 207
            _rm_test_img "$TEST_DIR/t.$IMGFMT"
            _rm_test_img "$TEST_DIR/t.$IMGFMT.orig"
            _rm_test_img "$TEST_DIR/t.$IMGFMT.base"
208 209 210 211
            if [ -n "$SAMPLE_IMG_FILE" ]
            then
                rm -f "$TEST_DIR/$SAMPLE_IMG_FILE"
            fi
212 213 214
            ;;

        rbd)
215
            rbd --no-progress rm "$TEST_DIR/t.$IMGFMT" > /dev/null
216 217
            ;;

218 219 220 221
        archipelago)
            vlmc remove "at.$IMGFMT" > /dev/null
            ;;

222
        sheepdog)
223
            collie vdi delete "$TEST_DIR/t.$IMGFMT"
224 225 226
            ;;

    esac
227 228 229 230
}

_check_test_img()
{
231 232 233 234 235 236
    (
        if [ "$IMGOPTSSYNTAX" = "true" ]; then
            $QEMU_IMG check $QEMU_IMG_EXTRA_ARGS "$@" "$TEST_IMG" 2>&1
        else
            $QEMU_IMG check "$@" -f $IMGFMT "$TEST_IMG" 2>&1
        fi
R
Reda Sallahi 已提交
237
    ) | _filter_testdir | _filter_qemu_img_check
238 239
}

240 241
_img_info()
{
242 243 244 245 246 247 248
    if [[ "$1" == "--format-specific" ]]; then
        local format_specific=1
        shift
    else
        local format_specific=0
    fi

249 250
    discard=0
    regex_json_spec_start='^ *"format-specific": \{'
251
    $QEMU_IMG info "$@" "$TEST_IMG" 2>&1 | \
252 253 254 255
        sed -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
            -e "s#$TEST_DIR#TEST_DIR#g" \
            -e "s#$IMGFMT#IMGFMT#g" \
            -e "/^disk size:/ D" \
256 257
            -e "/actual-size/ D" | \
        while IFS='' read line; do
258 259 260
            if [[ $format_specific == 1 ]]; then
                discard=0
            elif [[ $line == "Format specific information:" ]]; then
261 262 263 264 265 266 267 268 269 270 271 272 273 274
                discard=1
            elif [[ $line =~ $regex_json_spec_start ]]; then
                discard=2
                regex_json_spec_end="^${line%%[^ ]*}\\},? *$"
            fi
            if [[ $discard == 0 ]]; then
                echo "$line"
            elif [[ $discard == 1 && ! $line ]]; then
                echo
                discard=0
            elif [[ $discard == 2 && $line =~ $regex_json_spec_end ]]; then
                discard=0
            fi
        done
275 276
}

277 278 279 280
_get_pids_by_name()
{
    if [ $# -ne 1 ]
    then
K
Kevin Wolf 已提交
281 282
        echo "Usage: _get_pids_by_name process-name" 1>&2
        exit 1
283 284 285 286 287 288 289 290 291 292 293
    fi

    # Algorithm ... all ps(1) variants have a time of the form MM:SS or
    # HH:MM:SS before the psargs field, use this as the search anchor.
    #
    # Matches with $1 (process-name) occur if the first psarg is $1
    # or ends in /$1 ... the matching uses sed's regular expressions,
    # so passing a regex into $1 will work.

    ps $PS_ALL_FLAGS \
    | sed -n \
K
Kevin Wolf 已提交
294 295 296 297 298 299
        -e 's/$/ /' \
        -e 's/[         ][         ]*/ /g' \
        -e 's/^ //' \
        -e 's/^[^ ]* //' \
        -e "/[0-9]:[0-9][0-9]  *[^ ]*\/$1 /s/ .*//p" \
        -e "/[0-9]:[0-9][0-9]  *$1 /s/ .*//p"
300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316
}

# fqdn for localhost
#
_get_fqdn()
{
    host=`hostname`
    $NSLOOKUP_PROG $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
}

# check if run as root
#
_need_to_be_root()
{
    id=`id | $SED_PROG -e 's/(.*//' -e 's/.*=//'`
    if [ "$id" -ne 0 ]
    then
K
Kevin Wolf 已提交
317 318
        echo "Arrgh ... you need to be root (not uid=$id) to run this test"
        exit 1
319 320 321 322 323 324 325
    fi
}

# bail out, setting up .notrun file
#
_notrun()
{
M
Max Reitz 已提交
326
    echo "$*" >"$OUTPUT_DIR/$seq.notrun"
327 328 329 330 331 332 333 334 335
    echo "$seq not run: $*"
    status=0
    exit
}

# just plain bail out
#
_fail()
{
M
Max Reitz 已提交
336
    echo "$*" | tee -a "$OUTPUT_DIR/$seq.full"
337 338 339 340 341 342 343 344 345
    echo "(see $seq.full for details)"
    status=1
    exit 1
}

# tests whether $IMGFMT is one of the supported image formats for a test
#
_supported_fmt()
{
346 347 348
    # "generic" is suitable for most image formats. For some formats it doesn't
    # work, however (most notably read-only formats), so they can opt out by
    # setting IMGFMT_GENERIC to false.
349
    for f; do
350
        if [ "$f" = "$IMGFMT" -o "$f" = "generic" -a "$IMGFMT_GENERIC" = "true" ]; then
K
Kevin Wolf 已提交
351 352
            return
        fi
353 354 355 356 357
    done

    _notrun "not suitable for this image format: $IMGFMT"
}

358 359 360 361 362 363 364 365 366 367 368
# tests whether $IMGFMT is one of the unsupported image format for a test
#
_unsupported_fmt()
{
    for f; do
        if [ "$f" = "$IMGFMT" ]; then
            _notrun "not suitable for this image format: $IMGFMT"
        fi
    done
}

369 370 371 372 373
# tests whether $IMGPROTO is one of the supported image protocols for a test
#
_supported_proto()
{
    for f; do
K
Kevin Wolf 已提交
374 375 376
        if [ "$f" = "$IMGPROTO" -o "$f" = "generic" ]; then
            return
        fi
377 378 379 380 381
    done

    _notrun "not suitable for this image protocol: $IMGPROTO"
}

382 383 384 385 386 387
# tests whether the host OS is one of the supported OSes for a test
#
_supported_os()
{
    for h
    do
K
Kevin Wolf 已提交
388 389 390 391
        if [ "$h" = "$HOSTOS" ]
        then
            return
        fi
392 393 394 395 396
    done

    _notrun "not suitable for this OS: $HOSTOS"
}

397
_supported_cache_modes()
398
{
399 400 401 402
    for mode; do
        if [ "$mode" = "$CACHEMODE" ]; then
            return
        fi
403
    done
404 405 406 407 408 409 410 411 412 413
    _notrun "not suitable for cache mode: $CACHEMODE"
}

_default_cache_mode()
{
    if $CACHEMODE_IS_DEFAULT; then
        CACHEMODE="$1"
        QEMU_IO="$QEMU_IO --cache $1"
        return
    fi
414 415
}

416 417 418 419 420 421 422 423 424 425 426
_unsupported_imgopts()
{
    for bad_opt
    do
        if echo "$IMGOPTS" | grep -q 2>/dev/null "$bad_opt"
        then
            _notrun "not suitable for image option: $bad_opt"
        fi
    done
}

427 428 429 430
# this test requires that a specified command (executable) exists
#
_require_command()
{
431 432 433 434 435 436 437 438 439 440 441
    if [ "$1" = "QEMU" ]; then
        c=$QEMU_PROG
    elif [ "$1" = "QEMU_IMG" ]; then
        c=$QEMU_IMG_PROG
    elif [ "$1" = "QEMU_IO" ]; then
        c=$QEMU_IO_PROG
    elif [ "$1" = "QEMU_NBD" ]; then
        c=$QEMU_NBD_PROG
    else
        eval c=\$$1
    fi
442
    [ -x "$c" ] || _notrun "$1 utility required, skipped this test"
443 444 445 446
}

_full_imgfmt_details()
{
447 448 449 450 451
    if [ -n "$IMGOPTS" ]; then
        echo "$IMGFMT ($IMGOPTS)"
    else
        echo "$IMGFMT"
    fi
452 453
}

454 455 456 457 458
_full_imgproto_details()
{
    echo "$IMGPROTO"
}

459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491
_full_platform_details()
{
    os=`uname -s`
    host=`hostname -s`
    kernel=`uname -r`
    platform=`uname -m`
    echo "$os/$platform $host $kernel"
}

_link_out_file()
{
   if [ -z "$1" ]; then
      echo Error must pass \$seq.
      exit
   fi
   rm -f $1
   if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
      ln -s $1.irix $1
   elif [ "`uname`" == "Linux" ]; then
      ln -s $1.linux $1
   else
      echo Error test $seq does not run on the operating system: `uname`
      exit
   fi
}

_die()
{
        echo $@
        exit 1
}

# make sure this script returns success
492
true